//=========================================================================
//Copyright LizardOfOz.
//=========================================================================

BOSS_BAR_UPDATE_PERIOD <- 0.2;   //Boss bar update period (in seconds). Set to -1 to update every tick (~0.015s).
                                 //Needs to be less than 1 second for the health number to display correctly.
BOSS_BAR_HIDE_ON_DEATH <- true;
BOSS_BAR_CHANGE_SPEED <- 25;     //The speed of animation in health points at which the bar moves when taking damage.

//====================================
//Don't edit past this line
//====================================

Convars.SetValue("tf_rd_points_per_approach", BOSS_BAR_CHANGE_SPEED + "");
SetPropInt <- ::NetProps.SetPropInt.bindenv(::NetProps);
pd_logic <- Entities.FindByClassname(null, "tf_logic_player_destruction");
::bossEntity <- null;
isHudVisible <- false;

function SpawnBossBar()
{
    if (pd_logic != null)
        return;
    pd_logic = SpawnEntityFromTable("tf_logic_player_destruction", {
        blue_respawn_time = 0,
        finale_length = 999999,
        flag_reset_delay = 0,
        heal_distance = 0,
        min_points = 255,
        points_per_player = 0,
        red_respawn_time = 0,
        targetname = "pd_logic",
        res_file = "resource/ui/custom_boss_bar.res"
    });
    SetPropInt(pd_logic, "m_nBlueScore", 0);
    SetPropInt(pd_logic, "m_nBlueTargetPoints", 0);
    SetPropInt(pd_logic, "m_nMaxPoints", 255);
    EntFireByHandle(pd_logic, "SetPointsOnPlayerDeath", "0", -1, null, null);
    EntFireByHandle(pd_logic, "SetPointsOnPlayerDeath", "0", 0.1, null, null);
    EntFireByHandle(pd_logic, "SetPointsOnPlayerDeath", "0", 1, null, null);
    EntFireByHandle(pd_logic, "EnableMaxScoreUpdating", "", -1, null, null);
    EntFireByHandle(pd_logic, "DisableMaxScoreUpdating", "", 5, null, null);
}
SpawnBossBar();

function SetBossBarValue(currentHP, maxHP)
{
    if (currentHP > maxHP)
        maxHP = currentHP;
    if (currentHP > 1)
        currentHP++;
    SetPropInt(pd_logic, "m_nBlueScore", currentHP);
    SetPropInt(pd_logic, "m_nBlueTargetPoints", currentHP);
    SetPropInt(pd_logic, "m_nMaxPoints", maxHP);
    EntFireByHandle(pd_logic, "setcountdowntimer", currentHP + "", 0, null, null);
    if (floor(currentHP) <= 0 || floor(maxHP) <= 0)
    {
        EntFireByHandle(pd_logic, "setcountdowntimer", "0", 0, null, null);
        SetPropInt(pd_logic, "m_nMaxPoints", 0);
        isHudVisible = false;
    }
    else if (!isHudVisible)
    {
        isHudVisible = true;
    }
}

function Think()
{
    if (!bossEntity || !bossEntity.IsValid()
        || bossEntity.GetMaxHealth() <= 0
        || (BOSS_BAR_HIDE_ON_DEATH && NetProps.GetPropInt(bossEntity, "m_lifeState") != 0))
    {
        if (isHudVisible)
            SetBossBarValue(0, 0);
        return BOSS_BAR_UPDATE_PERIOD;
    }
    SetBossBarValue(bossEntity.GetHealth(), bossEntity.GetMaxHealth());
    return BOSS_BAR_UPDATE_PERIOD;
}

::SetBossEntity <- function(newBossEntity)
{
    bossEntity = newBossEntity;
}

/*
This is how we make CompilePal include custom files.
PrecacheModel("resource/ui/custom_boss_bar.res");
PrecacheModel("materials/hud/custom_boss_bar.vmt");
PrecacheModel("materials/hud/custom_boss_bar.vtf");
PrecacheModel("materials/hud/custom_boss_bar_surround.vmt");
PrecacheModel("materials/hud/custom_boss_bar_surround.vtf");
*/